import java.io.*;
import java.net.*;

public class MulticastReceiver {
	@SuppressWarnings("deprecation")
	private static MulticastSocket newMulticastSocketDeprecated(InetAddress grpAddr, int port)
	throws IOException {
		MulticastSocket socket = new MulticastSocket(port);
		socket.joinGroup(grpAddr);
		return socket;
	}
	private static MulticastSocket newMulticastSocket(InetAddress grpAddr, int port)
	throws IOException {
		InetSocketAddress isa = new InetSocketAddress(grpAddr, port);
		MulticastSocket socket = new MulticastSocket(isa);
		NetworkInterface ni = NetworkInterface.getByName("eth0");
		socket.setNetworkInterface(ni);
		return socket;
	}
	public static void main(String[] args) throws IOException {
		InetAddress grpAddr = InetAddress.getByName("224.0.0.251");
		int port = 5253;
		MulticastSocket socket = newMulticastSocketDeprecated(grpAddr, port);
		byte[] buffer = new byte[256];
		DatagramPacket packet = new DatagramPacket(buffer, buffer.length);
		while (true) {
			socket.receive(packet);
			String msg = new String(buffer, 0, packet.getLength());
			System.out.println("Reu de " + packet.getAddress() + " : " + msg);
		}
	}
}
