import java.io.*;
import java.net.*;

public class MulticastSender {
	@SuppressWarnings("deprecation")
	private static MulticastSocket newMulticastSocketDeprecated(InetAddress grpAddr, int port)
	throws IOException {
		MulticastSocket socket = new MulticastSocket(port);
		socket.joinGroup(grpAddr);
		return socket;
	}
	private static MulticastSocket newMulticastSocket(InetAddress grpAddr, int port)
	throws IOException {
		InetSocketAddress isa = new InetSocketAddress(grpAddr, port);
		MulticastSocket socket = new MulticastSocket(isa);
		NetworkInterface ni = NetworkInterface.getByName("eth0");
		socket.setNetworkInterface(ni);
		return socket;
	}
	public static void main(String[] args) throws IOException {
		String msg=(args.length == 1 ? args[0] : "Hello !");
		InetAddress grpAddr = InetAddress.getByName("224.0.0.251");
		int port = 5253;
		MulticastSocket socket = newMulticastSocketDeprecated(grpAddr, port);
		DatagramPacket packet;
		packet = new DatagramPacket(msg.getBytes(), msg.length(), grpAddr, port);
		System.out.print("Envoi de '"+msg+"' ... ");
		socket.send(packet);
		System.out.println("fait.");
		socket.close();
	}
}
